<template>
  <v-data-table
    :headers="headers"
    :loading="loading"
    :items="roles"
    :page="page"
    :items-per-page="pageSize"
    :server-items-length="total"
    class="elevation-1"
  >
    <template #item.registeredAt="{ item }">
      {{ toLocalDate(item.registeredAt) }}
    </template>

    <template #item.updatedAt="{ item }">
      {{ toLocalDate(item.updatedAt, '-') }}
    </template>
  </v-data-table>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { toLocalDate } from '~/helpers/format/time';
import { errorOptions } from '~/helpers/toast';

export default {
  name: 'RolesTable',
  data: () => ({
    loading: false,
    headers: [
      {
        text: 'Nombre',
        align: 'start',
        sortable: false,
        value: 'name',
      },
      {
        text: 'Fecha de registro',
        align: 'center',
        sortable: false,
        value: 'registeredAt',
      },
      {
        text: 'Fecha de actualización',
        align: 'center',
        sortable: false,
        value: 'updatedAt',
      },
    ],
  }),
  computed: {
    ...mapState({
      roles: state => state.company.roles.roles,
      page: state => state.company.roles.pageInfo.page,
      pageSize: state => state.company.roles.pageInfo.pageSize,
      total: state => state.company.roles.pageInfo.total,
    }),
  },
  async mounted() {
    await this.getRolesData();
  },
  methods: {
    toLocalDate,
    ...mapActions({
      getRoles: 'company/roles/getRoles',
    }),
    async getRolesData() {
      this.loading = true;
      try {
        await this.getRoles({});
      } catch (e) {
        this.$toast.error('No se ha podido obtener los roles de los usuarios', errorOptions);
      }
      this.loading = false;
    },
  },
};
</script>
